Summary:        A multi-module umbrella project for Jackson modules
Name:           jackson-modules-base
Version:        2.14.2
Release:        2%{?dist}
License:        Apache-2.0
URL:            https://github.com/FasterXML/jackson-modules-base
Source0:        %{url}/archive/%{name}-%{version}.tar.gz

Patch3000:      0001-Expose-javax.security.auth-from-JDK-internals.patch
Patch3001:      0001-Replace-javax.activation-imports-with-jakarta.activa.patch
Patch3002:      0001-Use-jakarta.activation-namespace-in-jaxb-api.patch

BuildRequires:  maven-local
BuildRequires:  mvn(cglib:cglib)
BuildRequires:  mvn(com.fasterxml.jackson.core:jackson-annotations) >= %{version}
BuildRequires:  mvn(com.fasterxml.jackson.core:jackson-core) >= %{version}
BuildRequires:  mvn(com.fasterxml.jackson.core:jackson-databind) >= %{version}
BuildRequires:  mvn(com.fasterxml.jackson:jackson-base:pom:) >= %{version}
BuildRequires:  mvn(com.google.code.maven-replacer-plugin:replacer)
BuildRequires:  mvn(jakarta.activation:jakarta.activation-api)
BuildRequires:  mvn(jakarta.xml.bind:jakarta.xml.bind-api)
BuildRequires:  mvn(junit:junit)
BuildRequires:  mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires:  mvn(org.mockito:mockito-all)
BuildRequires:  mvn(org.ow2.asm:asm)

BuildArch:      noarch
ExclusiveArch:  %{java_arches} noarch

%description
This is a multi-module umbrella project for Jackson modules
that are considered foundational, building on core databind,
but not including datatype or data format modules, or
JAX-/Jakarta-RS providers. Not all "general" modules are
included here; this grouping is to be used for more mature
(and generally slower moving, stable) modules.

%package -n jackson-module-jaxb-annotations
Summary: Support for using JAXB annotations as an alternative to "native" Jackson annotations

%description -n jackson-module-jaxb-annotations
This is a multi-module umbrella project for Jackson modules
that are considered foundational, building on core databind,
but not including datatype or data format modules, or
JAX-/Jakarta-RS providers. Not all "general" modules are
included here; this grouping is to be used for more mature
(and generally slower moving, stable) modules.


%prep
%autosetup -n %{name}-%{name}-%{version} -p1

%pom_remove_dep -r org.glassfish.jaxb:jaxb-runtime
%pom_remove_plugin "de.jjohannes:gradle-module-metadata-maven-plugin"
%pom_remove_plugin -r :moditect-maven-plugin
%pom_remove_plugin ":maven-shade-plugin" afterburner mrbean paranamer
%pom_xpath_remove "pom:properties/pom:osgi.private" mrbean paranamer

sed -i 's/\r//' mrbean/src/main/resources/META-INF/{LICENSE,NOTICE}
cp -p mrbean/src/main/resources/META-INF/{LICENSE,NOTICE} .

%pom_change_dep org.osgi:org.osgi.core org.osgi:osgi.core osgi

%pom_add_dep cglib:cglib:3.2.4:test guice

%pom_disable_module afterburner
%pom_disable_module guice
%pom_disable_module mrbean
%pom_disable_module osgi
%pom_disable_module paranamer
%pom_disable_module jakarta-xmlbind
%pom_disable_module blackbird
%pom_disable_module no-ctor-deser

%pom_add_plugin "org.apache.felix:maven-bundle-plugin" jaxb "
<configuration>
  <instructions>
    <Import-Package>javax.activation;resolution:=optional,*</Import-Package>
  </instructions>
</configuration>"

rm osgi/src/test/java/com/fasterxml/jackson/module/osgi/InjectOsgiServiceTest.java

%mvn_file ":{*}" jackson-modules/@1

%build
%mvn_build -s -j

%install
%mvn_install

%files -f .mfiles-jackson-modules-base
%license LICENSE NOTICE
%doc README.md release-notes

%files -n jackson-module-jaxb-annotations -f .mfiles-jackson-module-jaxb-annotations
%license LICENSE NOTICE
%doc jaxb/README.md jaxb/release-notes

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.14.2-2
- Rebuilt for OpenCloudOS Stream 23.05

* Mon Apr 24 2023 Miaojun Dong <zoedong@tencent.com> - 2.14.2-1
- initial build
